//----------------------------------------------------------------
//	SSRAM Test
//
//	dependency: none
//	2001, 11, 1
//	Author: Nelson Y.C. Chang
//
//----------------------------------------------------------------

#include <stdio.h>

//void d2b(int d_number, int array_len, int *b_number);
//void printB(int d_number, int array_len, int*b_number);




int main(void){
	unsigned int	CM_CTRL_ADDR = 0x1000000C;	
	unsigned int	SSRAM_ADDR = 0x00000000;	// CM's SSRAM ranges 0x0 ~ 0x0003FFFF
	
	unsigned int 	*CM_CTRL_PTR, *SSRAM_PTR, *SDRAM_PTR;

	unsigned int i;
	int SSRAM_test_error = 0;

	CM_CTRL_PTR = (unsigned int *) CM_CTRL_ADDR;
	SSRAM_PTR = (unsigned int *) SSRAM_ADDR;
	
	// Memory Remap to SSRAM
	*CM_CTRL_PTR =0x4;

	printf("SSRAM Write Test\n");
	printf("Press any key to start SSRAM test!!\n");

	getchar();
	*CM_CTRL_PTR =0x5;
	
	printf("Backup SSRAM data from 0x0000 to 0x8000 to SDRAM at 0x80000000\n");
	for(i=0;i<0x8000;i+=4)
	{
		SDRAM_PTR = (unsigned int *)(i+0x80000000);	
		SSRAM_PTR = (unsigned int *)(i+0x30000);
		*SDRAM_PTR = *SSRAM_PTR;
	}
	
	printf("Writing...\n");
	for(i=0;i<0x8000;i+=4)
	{
		SSRAM_PTR = (unsigned int *)(i+0x30000);
		*SSRAM_PTR = i;
	}

	printf("Verifying...\n");
	for(i=0x0;i<0x8000;i+=4)
	{
		SSRAM_PTR = (unsigned int *)(i+0x30000);
		if(*SSRAM_PTR != i)
		{
			printf("SSRAM W/R test error!!\n");
			printf("Error address>> %x\n",i);
			SSRAM_test_error = 1;
			getchar();
		}
	}
	if(SSRAM_test_error != 1)
		printf("SSRAM test passed!!\n");

	*CM_CTRL_PTR =0x4;
	printf("SSRAM test finished.\n");

	printf("Restore original SSRAM data from 0x00000000 to 0x80008000 to SSRAM at 0x8000\n");
	for(i=0;i<0x8000;i+=4)
	{
		SDRAM_PTR = (unsigned int *)(i+0x80000000);	
		SSRAM_PTR = (unsigned int *)(i+0x30000);
		*SSRAM_PTR = *SDRAM_PTR;
	}
		

	return 0;
}